
///////////////////////////////////////////////////////////////////////////////////////////////
// DATA DEMO
///////////////////////////////////////////////////////////////////////////////////////////////

function data_demo()
{

	if ( bLoggedIn == false )
	{
		alert("You are not logged In!!!");
		return;
	}

	oWin = new Form( "Query Demo", 510 , 370 );

	oGrid = new Grid( oWin, 40, 020, 480, 190, [ 'Code' , 'First' , 'Last' , 'Birth Date' , 'Married' ], 600 );

	Button( oWin , 240 , 020 , "Query Server" , "retrieve_data(oGrid);alert('Operation Completed')" );  

	Button( oWin , 240 , 140 , "Edit"   , "Edit( oGrid )"        );  

	Button( oWin , 240 , 260 , "Delete"   , "DeleteTest( oGrid )"        );  

	Button( oWin , 240 , 380 , "Append"          , "AppendTest( oGrid )"  );  

	Label( oWin , 290 , 130 , "Current Query: 'code<=40 .or. code>=1000'" );

	Button( oWin , 320 , 020 , "PDF Report"       , "pdf_report()" );  

	Button( oWin , 320 , 380 , "Close"            , "oWin.release()" );  

}
//---------------------------------------------------------------------------------------------//
function retrieve_data(oGrid) 
{

	// Get Recordset From Server

	aRecordSet = httpRequest ( '/cgi-bin/myapp.cgi' , 'query' , 
		[ 'code' , 'first' , 'last' , 'birth' , 'married' ] , 
		'code<=40 .or. code>=1000' , '' );

	// Delete All Rows

	while ( oGrid.getRowCount() > 1 )
	{
		oGrid.deleteRow(1);
	}

	// Fill Grid With Recordset

	for ( i = 0 ; i < aRecordSet.length ; i++ )
	{
		oGrid.addRow ( aRecordSet [i] );
	}

}

//---------------------------------------------------------------------------------------------//
function Edit(oGrid) 
{

	if ( oGrid.getSelectedRowCount() == 0 )
	{
		alert('No Row Selected!');
		return;
	}

	if ( oGrid.getSelectedRowCount() > 1 )
	{
		alert('You must select only one row!');
		return;
	}

	var aSelection = oGrid.getSelectedRows();
	nRow = aSelection [0] ;

	oWin = new Form( "Edit", 325 , 270 );

	Label( oWin , 65  , 40 , "Code:" );
	Label( oWin , 95  , 40 , "First:" );
	Label( oWin , 125 , 40 , "Last:" );

	Label( oWin , 155 , 40 , "Birth:" );
	Label( oWin , 185 , 40 , "Married:" );

	oCode  = new TextBox( oWin , 60  , 130, trim ( oGrid.getCell( nRow , 1 ) ) );
	oCode.disable();

	oFirst   = new TextBox( oWin , 90  , 130, trim( oGrid.getCell( nRow , 2 ) ) );
	oFirst.setFocus();
	oLast    = new TextBox( oWin , 120 , 130, trim ( oGrid.getCell( nRow , 3 ) ) );
	oBirth   = new DatePicker( oWin , 150, 130, oGrid.getCell( nRow , 4 ) );
	oMarried = new CheckBox( oWin , 180 , 130 , oGrid.getCell(nRow,5) );

	oOk     = new Button( oWin , 210 , 40 , "Ok" , "EditOk(oWin,oGrid)" );  
	oCancel = new Button( oWin , 210 , 170 , "Cancel" , "oWin.release()" );  


}

//---------------------------------------------------------------------------------------------//
function EditOk(oWin,oGrid)
{

	httpRequest('/cgi-bin/myapp.cgi', 'modify', [ 'first' , 'last' , 'birth' , 'married' ] , [ oFirst.getValue() , oLast.getValue() , oBirth.getValue() , oMarried.getValue() ] , 'code=' + trim(oCode.getValue()) );

	retrieve_data(oGrid)

	oWin.release();

}

//---------------------------------------------------------------------------------------------//
function DeleteTest(oGrid)
{

	if ( oGrid.getSelectedRowCount() == 0 )
	{
		alert('No Rows Selected!');
		return;
	}

	var r = confirm("Are You Sure?");
	if (r == true)
	{

		var aSelection = oGrid.getSelectedRows();

		for ( i = 0 ; i < aSelection.length ; i++ )
		{
			xcode  = oGrid.getCell( aSelection [i] , 1 );

			httpRequest('/cgi-bin/myapp.cgi', 'delete', 'code=' + xcode );

		}

		retrieve_data(oGrid)

		alert('Operation Completed!')

	}

}

//---------------------------------------------------------------------------------------------//
function AppendTest( oGrid ) 
{

	oWin = new Form( "Append", 325 , 270 );

	Label( oWin , 65  , 40 , "Code:" );
	Label( oWin , 95  , 40 , "First:" );
	Label( oWin , 125 , 40 , "Last:" );

	Label( oWin , 155 , 40 , "Birth:" );
	Label( oWin , 185 , 40 , "Married:" );

	oCode    = new TextBox( oWin , 60  , 130, "" );
	oFirst   = new TextBox( oWin , 90  , 130, "" );
	oLast    = new TextBox( oWin , 120 , 130, "" );
	oBirth   = new DatePicker( oWin , 150, 130, "" );
	oMarried = new CheckBox( oWin , 180 , 130 , "" );

	oOk     = new Button( oWin , 210 , 40 , "Ok" , "AppendOk(oWin,oGrid)" );  
	oCancel = new Button( oWin , 210 , 170 , "Cancel" , "oWin.release()" );  

	oCode.setFocus();

}

//---------------------------------------------------------------------------------------------//
function AppendOk(oWin,oGrid)
{

	httpRequest('/cgi-bin/myapp.cgi', 'append' , [ 'code' , 'first' , 'last' , 'birth' , 'married' ] , [ oCode.getValue() , oFirst.getValue() , oLast.getValue() , oBirth.getValue() , oMarried.getValue() ] );

	retrieve_data(oGrid)

	oWin.release();

}

//---------------------------------------------------------------------------------------------//
function pdf_report()
{

	// Get Recordset From Server

	aRecordSet = httpRequest ( '/cgi-bin/myapp.cgi' , 'query' , 
		[ 'code' , 'first' , 'last' , 'birth' , 'married' ] , 
		'code<=40 .or. code>=1000' , '' );

	var doc = new jsPDF();


	doc.setFont("courier");
	doc.setFontType("normal");

	doc.text( 20  , 15  , 'CODE' );
	doc.text( 45  , 15  , 'FIRST' );
	doc.text( 90  , 15  , 'LAST' );
	doc.text( 135 , 15  , 'BIRTH' );
	doc.text( 176 , 15  , 'MARRIED' );

	doc.text( 16  , 20  , '------------------------------------------------------' );

	currentRow = 0;

	for ( var i = 0 ; i < aRecordSet.length ; i++ )
	{

		aRow = aRecordSet [i]; 

		for( var n = 0; n < aRow.length; n++ )
		{	

			doc.text( n * 45  , 20 + ( ( currentRow + 1 ) * 6 ) , aRow [ n ] );

		}

		currentRow++;

	}


	// Output in new window
	doc.output('dataurlnewwindow');


}


