
///////////////////////////////////////////////////////////////////////////////////////////////
// PDF DEMOS
///////////////////////////////////////////////////////////////////////////////////////////////

function pdf_demos() 
{

	oWin = new Form( "PDF Demos", 620 , 300 );

	Label( oWin , 50 , 70 , "Generated PDFs are shown in new tabs, but they could be saved to disk instead." );
	Label( oWin , 70 , 200 , "Take a look at source ('pdf.demos.js')." );

	oCombo2 = new ComboBox( oWin , 120 , 260 , 
 	[ 'Select...' , 'TwoPageDoc'            , 'Landscape'       , 'FontSizes'       , 'FontTypes'        , 'TextColors'       , 'Metadata'       , 'UserInput'       , 'Rectangles'       , 'Lines'       , 'Circles'       , 'Triangles'       ] , 
	[ ''          , 'demoTwoPageDocument()' , 'demoLandscape()' , 'demoFontSizes()' , 'demoFontTypes()'  , 'demoTextColors()' , 'demoMetadata()' , 'demoUserInput()' , 'demoRectangles()' , 'demoLines()' , 'demoCircles()' , 'demoTriangles()' ] , 
	0 , "eval(this.options[this.selectedIndex].value);" );

	Button( oWin , 240 , 255 , "Close"            , "oWin.release()" );  

}


function demoTwoPageDocument() {
	var doc = new jsPDF();
	doc.text(20, 20, 'Hello world!');
	doc.text(20, 30, 'This is client-side Javascript, pumping out a PDF.');
	doc.addPage();
	doc.text(20, 20, 'Do you like that?');
	
	// Save the PDF
	// doc.save('Test.pdf');

	// Output in new window
	doc.output('dataurlnewwindow');


}

function demoLandscape() {
	var doc = new jsPDF('landscape');
	doc.text(20, 20, 'Hello landscape world!');

	// Save the PDF
	// doc.save('Test.pdf');
	// Output in new window
	doc.output('dataurlnewwindow');


}

function demoFontSizes() {
	var doc = new jsPDF();
	doc.setFontSize(22);
	doc.text(20, 20, 'This is a title');
	
	doc.setFontSize(16);
	doc.text(20, 30, 'This is some normal sized text underneath.');
	
	// doc.save('Test.pdf');
	// Output in new window
	doc.output('dataurlnewwindow');


}

function demoFontTypes() {
	var doc = new jsPDF();
	
	doc.text(20, 20, 'This is the default font.');
	
	doc.setFont("courier");
	doc.setFontType("normal");
	doc.text(20, 30, 'This is courier normal.');
	
	doc.setFont("times");
	doc.setFontType("italic");
	doc.text(20, 40, 'This is times italic.');
	
	doc.setFont("helvetica");
	doc.setFontType("bold");
	doc.text(20, 50, 'This is helvetica bold.');
	
	doc.setFont("courier");
	doc.setFontType("bolditalic");
	doc.text(20, 60, 'This is courier bolditalic.');
	
	// doc.save('Test.pdf');

	// Output in new window
	doc.output('dataurlnewwindow');

}

function demoTextColors() {
	var doc = new jsPDF();

	doc.setTextColor(100);
	doc.text(20, 20, 'This is gray.');
	
	doc.setTextColor(150);
	doc.text(20, 30, 'This is light gray.');
	
	doc.setTextColor(255,0,0);
	doc.text(20, 40, 'This is red.');
	
	doc.setTextColor(0,255,0);
	doc.text(20, 50, 'This is green.');
	
	doc.setTextColor(0,0,255);
	doc.text(20, 60, 'This is blue.');
	
	// Output in new window
	doc.output('dataurlnewwindow');

}

function demoMetadata() {
	var doc = new jsPDF();
	doc.text(20, 20, 'This PDF has a title, subject, author, keywords and a creator.');
	
	// Optional - set properties on the document
	doc.setProperties({
		title: 'Title',
		subject: 'This is the subject',
		author: 'James Hall',
		keywords: 'generated, javascript, web 2.0, ajax',
		creator: 'MEEE'
	});
	
	// doc.save('Test.pdf');
	// Output in new window
	doc.output('dataurlnewwindow');

}

function demoUserInput() {	
	var name = prompt('What is your name?');
	var multiplier = prompt('Enter a number:');
	multiplier = parseInt(multiplier);

	var doc = new jsPDF();
	doc.setFontSize(22);	
	doc.text(20, 20, 'Questions');
	doc.setFontSize(16);
	doc.text(20, 30, 'This belongs to: ' + name);
	
	for(var i = 1; i <= 12; i ++) {
		doc.text(20, 30 + (i * 10), i + ' x ' + multiplier + ' = ___');
	}
	
	doc.addPage();
	doc.setFontSize(22);
	doc.text(20, 20, 'Answers');
	doc.setFontSize(16);
	
	for (i = 1; i <= 12; i ++) {
		doc.text(20, 30 + (i * 10), i + ' x ' + multiplier + ' = ' + (i * multiplier));
	}

	// doc.save('Test.pdf');
	// Output in new window
	doc.output('dataurlnewwindow');

	
}

function demoRectangles() {
	var doc = new jsPDF();

	doc.rect(20, 20, 10, 10); // empty square

	doc.rect(40, 20, 10, 10, 'F'); // filled square
	
	doc.setDrawColor(255, 0, 0);
	doc.rect(60, 20, 10, 10); // empty red square
	
	doc.setDrawColor(255, 0, 0);
	doc.rect(80, 20, 10, 10, 'FD'); // filled square with red borders
	
	doc.setDrawColor(0);
	doc.setFillColor(255, 0, 0);
	doc.rect(100, 20, 10, 10, 'F'); // filled red square
	
	doc.setDrawColor(0);
	doc.setFillColor(255, 0, 0);
	doc.rect(120, 20, 10, 10, 'FD'); // filled red square with black borders

	doc.setDrawColor(0);
	doc.setFillColor(255, 255, 255);
	doc.roundedRect(140, 20, 10, 10, 3, 3, 'FD'); //  Black sqaure with rounded corners

	// doc.save('Test.pdf');

	// Output in new window
	doc.output('dataurlnewwindow');


}

function demoLines() {
	var doc = new jsPDF();

	doc.line(20, 20, 60, 20); // horizontal line
		
	doc.setLineWidth(0.5);
	doc.line(20, 25, 60, 25);
	
	doc.setLineWidth(1);
	doc.line(20, 30, 60, 30);
	
	doc.setLineWidth(1.5);
	doc.line(20, 35, 60, 35);
	
	doc.setDrawColor(255,0,0); // draw red lines
	
	doc.setLineWidth(0.1);
	doc.line(100, 20, 100, 60); // vertical line
	
	doc.setLineWidth(0.5);
	doc.line(105, 20, 105, 60);
	
	doc.setLineWidth(1);
	doc.line(110, 20, 110, 60);
	
	doc.setLineWidth(1.5);
	doc.line(115, 20, 115, 60);
	
	// Output in new window
	doc.output('dataurlnewwindow');

}

function demoCircles() {
	var doc = new jsPDF();

	doc.ellipse(40, 20, 10, 5);

	doc.setFillColor(0,0,255);
	doc.ellipse(80, 20, 10, 5, 'F');
	
	doc.setLineWidth(1);
	doc.setDrawColor(0);
	doc.setFillColor(255,0,0);
	doc.circle(120, 20, 5, 'FD');

	// doc.save('Test.pdf');

	// Output in new window
	doc.output('dataurlnewwindow');

}

function demoTriangles() {
	var doc = new jsPDF();

	doc.triangle(60, 100, 60, 120, 80, 110, 'FD');
	
	doc.setLineWidth(1);
	doc.setDrawColor(255,0,0);
	doc.setFillColor(0,0,255);
	doc.triangle(100, 100, 110, 100, 120, 130, 'FD');
	
	// doc.save('Test.pdf');

	// Output in new window
	doc.output('dataurlnewwindow');

}


